using Benchmark;
using NUnit.Framework;

namespace TestProject1
{
    public class Tests
    {
        [SetUp]
        public void Setup()
        {
        }

        [Test]
        public void Test3()
        {
            var actual = new TrailingNumberFromString().GetTrailingNumberFromString3();
            Assert.AreEqual(1234, actual);
        }

        [Test]
        public void Test4()
        {
            var actual = new TrailingNumberFromString().GetTrailingNumberFromString4();
            Assert.AreEqual(1234, actual);
        }

        [Test]
        public void Test5()
        {
            var actual = new TrailingNumberFromString().GetTrailingNumberFromString5();
            Assert.AreEqual(1234, actual);
        }

        [Test]
        public void Test6()
        {
            var actual = new IdentityParser().Parse1();
            Assert.AreEqual("ABZ", actual?.Prefix);
            Assert.AreEqual(1, actual?.Index);
            Assert.AreEqual(1, actual?.Revision);
        }

        [Test]
        public void Test7()
        {
            var actual = new IdentityParser().Parse2();
            Assert.AreEqual("ABZ", actual?.Prefix);
            Assert.AreEqual(1, actual?.Index);
            Assert.AreEqual(1, actual?.Revision);
        }

        [Test]
        public void Test8()
        {
            Assert.IsTrue(Identity.TryParse("TOPFTP0000123-12", out var actual));
            Assert.AreEqual("TOPFTP", actual.Prefix);
            Assert.AreEqual(123, actual.Index);
            Assert.AreEqual(12, actual.Revision);
        }
        
        [Test]
        public void Test9()
        {
            Assert.IsTrue(Identity.TryParse("WPR0001023-12", out var actual));
            Assert.AreEqual("WPR", actual.Prefix);
            Assert.AreEqual(1023, actual.Index);
            Assert.AreEqual(12, actual.Revision);
        }
        
        [Test]
        public void Test10()
        {
            Assert.IsFalse(Identity.TryParse("WPR0001023+12", out _));
            Assert.IsFalse(Identity.TryParse("Peter", out _));
            Assert.IsFalse(Identity.TryParse("NCL1-1", out _));
            Assert.IsFalse(Identity.TryParse("NCL0000001-0", out _));
            Assert.IsFalse(Identity.TryParse("NCL0000000-1", out _));
            Assert.IsFalse(Identity.TryParse("Nc0000001-1", out _));
            Assert.IsFalse(Identity.TryParse("0000001-1", out _));
        }        
    }
}